<template>
  <div><slot/></div>
</template>

<script>
import { Control, DomEvent } from 'leaflet'
import { findParentComponentByName } from '@/core/util'

export default {
  name: 'leafletcontrol',

  props: {
    position: {
      type: String,
      default: 'topleft'
    },
  },

  computed: {
    leafletMap: {
      get() {
        return findParentComponentByName(this.$parent, 'leafletmap')
      }
    },
  },

  mounted() {
    const LControl = Control.extend({
      element: undefined,
      onAdd() {
        return this.element
      },
      setElement(el) {
        this.element = el
      }
    })

    this.controlObject = new LControl({
      position: this.position
    })
    this.controlObject.setElement(this.$el)
    DomEvent.disableClickPropagation(this.$el)
    this.controlObject.addTo(this.leafletMap.mapObject)
  }
}
</script>
